﻿using System.Windows;
using System.Windows.Controls;
using VSTalk.Engine.ViewModel.ContactList.ClientResources;
using VSTalk.Model;

namespace VSTalk.Engine.Controls
{
    class InterlocutorToolTip : Control
    {
        public static readonly DependencyProperty InterlocutorProperty = DependencyProperty.Register
            (
                 "Interlocutor",
                 typeof(Interlocutor),
                 typeof(InterlocutorToolTip),
                 new PropertyMetadata(null)
            );

        public Interlocutor Interlocutor
        {
            get { return (Interlocutor)GetValue(InterlocutorProperty); }
            set { SetValue(InterlocutorProperty, value); }
        }

        private InterlocuterSummaryViewModel _interlocuterSummary;

        public InterlocuterSummaryViewModel InterlocuterSummary
        {
            get
            {
                if (_interlocuterSummary == null)
                    _interlocuterSummary = new InterlocuterSummaryViewModel(Interlocutor);
                return _interlocuterSummary;
            }
        }

        static InterlocutorToolTip()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(InterlocutorToolTip), new FrameworkPropertyMetadata(typeof(InterlocutorToolTip)));
        }
    }
}
