using VSTalk.Engine.Core.History;
using VSTalk.Engine.Settings;

namespace VSTalk.Engine.Core.Context
{
    public class ModelContextSaver : IModelContextSaver
    {
        public IAccountSerializer Serializer { get; set; }

        private IModelContext _context;

        public ModelContextSaver()
        {
            Serializer = new FileAccountSerializer();
        }

        public void Save(IModelContext context)
        {
            _context = context;
            SaveHistory();
            SaveAccount();
        }

        private void SaveAccount()
        {
            Serializer.Serialize(_context.Account);
        }

        private void SaveHistory()
        {
            AppServices.Get<IHistoryService>().Save();
        }
    }
}