﻿using System.Collections.Generic;

using VSTalk.Logger;

using agsXMPP;
using agsXMPP.protocol.iq.disco;

using log4net;

namespace VSTalk.Engine.Core.Disco
{
    public class DiscoRepository
    {
        private static readonly ILog _log = LoggerFactory.Create<DiscoRepository>();

        private readonly IDictionary<Jid, DiscoInfo> _items = new Dictionary<Jid, DiscoInfo>();

        public void UpdateDisco(Jid jid, DiscoInfo info)
        {
            _log.InfoFormat("Updating disco for jid:{0}", jid);
            _items[jid] = info;
        }

        public DiscoInfo GetDisco(Jid jid)
        {
            if (_items.ContainsKey(jid))
            {
                return _items[jid];
            }
            _log.WarnFormat("There is no disco for jid:{0}", jid);
            return null;
        }

        public bool ContainsJid(Jid jid)
        {
            return _items.ContainsKey(jid);
        }
    }
}