﻿using System.ComponentModel;

using VSTalk.Model;
using VSTalk.Tools;

using agsXMPP;

namespace VSTalk.Engine.Core.EntitySession
{
    internal class InterlocutorResource : IInterlocutorResource
    {
        private ShowType _show;
        private string _status;
        private ContactState _state = ContactState.Offline;

        public InterlocutorResource(Jid jid)
        {
            Jid = jid;
        }

        public Jid Jid { get; private set; }

        public ShowType Show
        {
            get { return _show; }
            set
            {
                _show = value;
                PropertyChanged.Notify(() => Show);
            }
        }

        public string Status
        {
            get { return _status; }
            set
            {
                _status = value;
                PropertyChanged.Notify(() => Status);
            }
        }

        public ContactState State
        {
            get { return _state; }
            set
            {
                _state = value;
                PropertyChanged.Notify(() => State);
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}