﻿using System;
using System.Windows.Controls;

using VSTalk.Engine.View;
using VSTalk.Engine.ViewModel;

namespace VSTalk.Engine.Core.EnvironmentManagers.UI.Builders
{
    public class MainControlBuilder : IControlBuilder
    {
        private MainViewModel _context;
        private MainControl _control;

        public Type ControlType { get { return typeof(MainControl); } }
        public Type ContextType { get { return typeof(MainViewModel); } }
        public UserControl Create()
        {
            if (_context == null)
            {
                _context = new MainViewModel();
                _context.StartListen();
            }
            if (_control == null)
            {
                _control = new MainControl();
            }
            if (_control.DataContext == _context)
            {
                return _control;
            }
            _control.DataContext = _context;
            return _control;
        } 
    }
}