﻿using System.Collections.ObjectModel;

using VSTalk.Logger;

using log4net;

namespace VSTalk.Engine.Core.Notifications
{
    public class NotificationQueue : INotificationQueue
    {
        private static readonly ILog _log = LoggerFactory.Create(typeof(NotificationQueue));

        public ObservableCollection<INotificationMessage> Messages { get; private set; }

        public NotificationQueue()
        {
            Messages = new ObservableCollection<INotificationMessage>();
        }

        public void Remove(INotificationMessage notification)
        {
            Messages.Remove(notification);
        }

        public void PushToFront(INotificationMessage message)
        {
            _log.InfoFormat("Notifying user about: {0} {1}", message.Title, message.Message);
            Messages.Insert(0, message);
        }

        public void PushBack(INotificationMessage message)
        {
            _log.InfoFormat("Notifying user about: {0} {1}", message.Title, message.Message);
            Messages.Add(message);
        }
    }
}