using System;

namespace VSTalk.Engine.ViewModel.ContactList.Filter
{
    public class GenericResourceFilter
    {
        private Action<IClientResource, FilterParam> filter; 

        private GenericResourceFilter()
        {
        }

        public void Apply(IClientResource resource, FilterParam param)
        {
            filter(resource, param);
        }

        public static GenericResourceFilter MakeFilter<T>(IResourceFilter<T> actualFilter) where T : IClientResource
        {
            var genericFilter = new GenericResourceFilter();
            genericFilter.filter = (resource, param) =>
            {
                if (resource is T)
                {
                    actualFilter.Apply((T) resource, param);
                }
                else
                {
                    param.Result = FilterResult.Accept;
                }
            };
            return genericFilter;
        }

    }
}