using VSTalk.Engine.Core.EntitySession;
using VSTalk.Engine.ViewModel.ContactList.ClientResources;
using VSTalk.Model;

namespace VSTalk.Engine.ViewModel.ContactList.Filter
{
    public class HideOfflineContactFilter : IResourceFilter<InterlocutorResourceViewModel>
    {
        private static ISessionModel SessionModel
        {
            get { return AppServices.Get<ISessionModel>(); }
        }

        private bool ShowOffline
        {
            get { return Properties.Settings.Default.ShowOfflineContacts; }
        }

        public void Apply(InterlocutorResourceViewModel clientResource, FilterParam param)
        {
            if (!ShowOffline)
            {
                var context = SessionModel.GetInterlocutorContext(clientResource.Interlocutor);
                if (context.State == ContactState.Offline)
                {
                    param.Result = FilterResult.Reject;
                    return;
                }
            }
            param.Result = FilterResult.Accept;
        }
    }
}