﻿using System.ComponentModel;

using VSTalk.Engine.Core.ClientManager;
using VSTalk.Tools;

namespace VSTalk.Engine.ViewModel.Editors.ClientEditor
{
    public class ClientInfo : IClientInfo, INotifyPropertyChanged
    {
        private string _login;
        private string _password;
        private string _server;

        public string Login
        {
            get { return _login; }
            set
            {
                _login = value;
                PropertyChanged.Notify(() => Login);
            }
        }

        public string Password
        {
            get { return _password; }
            set
            {
                _password = value;
                PropertyChanged.Notify(() => Password);
            }
        }

        public string Server
        {
            get { return _server; }
            set
            {
                _server = value;
                PropertyChanged.Notify(() => Server);
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}