﻿using System.ComponentModel;

using VSTalk.Engine.Core.XmppCommunication.Services.RoomManager;
using VSTalk.Tools;

namespace VSTalk.Engine.ViewModel.Editors.RoomEditor
{
    public class RoomInfo : IRoomInfo, INotifyPropertyChanged
    {
        private string _roomName;
        private string _server;
        private string _nickname;

        public string RoomName
        {
            get { return _roomName; }
            set
            {
                _roomName = value;
                PropertyChanged.Notify(() => RoomName);
            }
        }

        public string Server
        {
            get { return _server; }
            set
            {
                _server = value;
                PropertyChanged.Notify(() => Server);
            }
        }

        public string Nickname
        {
            get { return _nickname; }
            set
            {
                _nickname = value;
                PropertyChanged.Notify(() => Nickname);
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}