﻿using System.Collections.ObjectModel;
using System.ComponentModel;

using VSTalk.Engine.Utils;
using VSTalk.Model;

namespace VSTalk.Engine.ViewModel.Messenger
{
    public interface IFrameViewModel : INotifyPropertyChanged
    {
        IChatViewModel CurrentChat { get; set; }
        ObservableCollection<IChatViewModel> ActiveChats { get; set; }
        
        RelayCommand PasteCallStack { get; }
        RelayCommand PasteDebugOutput { get; }
        
        bool IsActive { get; }

        void AttachEntity(Interlocutor interlocutor);
        void AttachEntity(Room room);
    }
}