﻿using VSTalk.Engine.Core.Feed;
using VSTalk.Model;

namespace VSTalk.Engine.ViewModel.Messenger.ThreadRenderer
{
    public class ContentMessageRenderer : IMessageRenderer
    {
        private readonly EntityThread _thread;

        private readonly ContentBlockCreator _blockCreator;

        public ContentMessageRenderer(EntityThread thread, Client client)
        {
            _thread = thread;
            _blockCreator = new ContentBlockCreator(client);
        }

        public void Push(IMessage message)
        {
            if (string.IsNullOrEmpty(message.XmppMessage.Body)) return;
            var block = _blockCreator.CreateBlock(message);
            _thread.Body.Blocks.Add(block.Element);
        }
    }
}