﻿using System.Collections.Generic;
using System.Windows.Documents;

using VSTalk.Engine.Core.Feed;

namespace VSTalk.Engine.ViewModel.Messenger.ThreadRenderer
{
    public class EntityThread
    {
        private FlowDocument Document { get; set; }

        public Section Body { get; set; }
        public Section Footer { get; set; }

        private readonly IList<IMessageRenderer> _renderers = new List<IMessageRenderer>();

        public IList<IMessageRenderer> Renderers
        {
            get { return _renderers; }
        }

        public EntityThread(FlowDocument document)
        {
            Document = document;
            Body = new Section();
            Footer = new Section();
            Document.Blocks.Add(Body);
            Document.Blocks.Add(Footer);
        }

        public void Push(IMessage message)
        {
            foreach (var messageRenderer in _renderers)
            {
                messageRenderer.Push(message);
            }
        }
    }
}