﻿using VSTalk.Engine.Core.Feed;
using VSTalk.Model;

namespace VSTalk.Engine.ViewModel.Messenger.ThreadRenderer
{
    public class SubjectMessageRenderer : IMessageRenderer
    {
        private readonly EntityThread _thread;

        private readonly SubjectBlockCreator _blockCreator;
        public SubjectMessageRenderer(EntityThread thread, Client client)
        {
            _thread = thread;
            _blockCreator = new SubjectBlockCreator(client);
        }

        public void Push(IMessage message)
        {
            if (string.IsNullOrEmpty(message.XmppMessage.Subject)) return;
            var block = _blockCreator.CreateBlock(message);
            _thread.Body.Blocks.Add(block.Element);
        }
    }
}